package com.jscape.inet.ssh.protocol.v2.marshaling;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.inet.ssh.protocol.v2.messages.SshMsgChannelWindowAdjust;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshMsgChannelWindowAdjustCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        int recipientChannel = Uint32Codec.readValue(in);
        long bytesToAdd = Uint32Codec.readLongValue(in);

        return new SshMsgChannelWindowAdjust(recipientChannel, bytesToAdd);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshMsgChannelWindowAdjust message = (SshMsgChannelWindowAdjust) value;
        Uint32Codec.writeValue(message.recipientChannel, out);
        Uint32Codec.writeValue(message.bytesToAdd, out);
    }
}
